﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace gdtLibrary
{
    // 게임 개체들을 관리하기 위한 게임 메니져
    public class GameMgr
    {
        private static GameMgr instance = null;
        public static GameMgr Instance { get { return instance; } }

        private SpriteBatch spriteBatch;
        private GraphicsDevice graphicsDevice;
        private List<RenderableObject> renderableObjects;

        // 스프라이트를 공급
        public SpriteBatch SpriteBatch { get { return spriteBatch; } }

        // 장치를 공급
        public GraphicsDevice GraphicsDevice { get { return graphicsDevice; } }

        // 렌더러블 오브젝트를 관리
        public List<RenderableObject> Objects { get { return renderableObjects; } }

        public GameMgr(GraphicsDevice device)
        {
            GameMgr.instance = this;
            this.graphicsDevice = device;
            this.spriteBatch = new SpriteBatch(device);
            this.renderableObjects = new List<RenderableObject>();
        }

        // 렌더링 전에 렌더링 준비를 시킴
        public void ReadyToRender(GameTime gameTime)
        {
            // 아직은 아무것도 하지 않음
        }

        public void Render(GameTime gameTime)
        {
            // 뷰포트만 뽑아내서 렌더링함

            foreach (RenderableObject _object in renderableObjects)
            {
                // 개체가 뷰포트인지를 확인하고
                if (_object is Viewport)
                    _object.Render(null, gameTime); // 렌더링
            }
        }
    }
}
